//
//  UIButton+KGButton.m
//  KG
//
//  Created by 北师智慧 on 2020/1/20.
//  Copyright © 2020 Heart likes static water. All rights reserved.
//

#import "UIButton+KGButton.h"
#import <objc/runtime.h>


static char *const kg_eventIntervalKey = "kg_eventIntervalKey";
static char *const eventUnavailableKey = "eventUnavailableKey";

@interface UIButton ()

@property(nonatomic,assign) BOOL eventUnavailable;

@end

@implementation UIButton (KGButton)

@dynamic kg_Type;

+ (void)load{
    Method method = class_getInstanceMethod(self, @selector(sendAction:to:forEvent:));
    Method kg_method = class_getInstanceMethod(self, @selector(kg_sendAction:to:forEvent:));
    method_exchangeImplementations(method, kg_method);
}

- (void)kg_sendAction:(SEL)action to:(id)target forEvent:(UIEvent *)event{
    if ([self isKindOfClass:[UIButton class]]) {
        if (self.eventUnavailable == NO) {
            self.eventUnavailable = YES;
            [self kg_sendAction:action to:target forEvent:event];
            [self performSelector:@selector(setEventUnavailable:) withObject:0 afterDelay:self.kg_Interval];
        }
    }else{
        [self kg_sendAction:action to:target forEvent:event];
    }
}

- (NSTimeInterval)kg_Interval{
    return [objc_getAssociatedObject(self, kg_eventIntervalKey) doubleValue];
}

- (void)setKg_Interval:(NSTimeInterval)kg_Interval{
    objc_setAssociatedObject(self, kg_eventIntervalKey, @(kg_Interval), OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

- (BOOL)eventUnavailable{
    return [objc_getAssociatedObject(self, eventUnavailableKey) boolValue];
}

- (void)setEventUnavailable:(BOOL)eventUnavailable{
    objc_setAssociatedObject(self, eventUnavailableKey, @(eventUnavailable), OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

- (void)setKg_Type:(KGButtonType)kg_Type{
    if (kg_Type == KGButtonTypeLeftTitleAndRightImg) {
        self.titleEdgeInsets = UIEdgeInsetsMake(0, -self.imageView.bounds.size.width, 0, self.imageView.bounds.size.width+10);
        self.imageEdgeInsets = UIEdgeInsetsMake(0, self.titleLabel.bounds.size.width, 0, -self.titleLabel.bounds.size.width-10);
    }else if(kg_Type == KGButtonTypeTopImg){
        self.titleEdgeInsets = UIEdgeInsetsMake(self.imageView.frame.size.height + 10.0, - self.imageView.bounds.size.width, .0, .0);
        self.imageEdgeInsets = UIEdgeInsetsMake(.0, self.titleLabel.bounds.size.width / 2, self.titleLabel.frame.size.height + 10.0, - self.titleLabel.bounds.size.width / 2);
    }
}


@end
